
#include	<windows.h>
#include	<wingdi.h>
#include 	<commctrl.h>
#include	<new.h>
#include	<stdio.h>
#include	<shlobj.h>
#include	<process.h>
#include	<dir.h>
#include	<math.h>
#include	"resource.h"
#include	"bosewime.h"
#include	"dll\\hook.h"
#include	"status.cpp"
#include	"dialog.cpp"



//	CvO
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPreInst, LPSTR lpszCmdLine, int nCmdShow )
{
	WNDCLASSEX	wc;
	MSG			msg;
	HWND		hWnd;
	char		szMutexName[] = "bosewimeMutexName";
	HANDLE		hMutex;

	//	dNh~
	hMutex = OpenMutex( MUTEX_ALL_ACCESS, FALSE, szMutexName );
	if( hMutex == NULL ){
		hMutex = CreateMutex( FALSE, 0, szMutexName );
	}else{
		CloseHandle( hMutex );
		return( FALSE );
	}

	GhInst = hInstance;

	//	pX쐬
	DWORD	dwLen;
	dwLen = GetModuleFileName( NULL, (LPTSTR)GsModuleFolderPath, (DWORD)sizeof(GsModuleFolderPath) );
		//	init@Cp
	lstrcpy( GsIniPath, GsModuleFolderPath );
	GsIniPath[dwLen-3]='i';
	GsIniPath[dwLen-2]='n';
	GsIniPath[dwLen-1]='i';
		//	vO{̗p
	int		p;
	p = dwLen-1;
	while( GsModuleFolderPath[p] != '\\' ){ p--; }
	GsModuleFolderPath[p+1] = '\0';

	//	CEBhEo^
	wc.cbSize		= sizeof(WNDCLASSEX);
	wc.style		= NULL;//CS_HREDRAW | CS_VREDRAW;//CS_BYTEALIGNWINDOW;// | CS_PARENTDC;//NULL;
	wc.lpfnWndProc	= MainWndProc;
	wc.cbClsExtra	= 0;
	wc.cbWndExtra	= 0;
	wc.hInstance	= GhInst;
	wc.hIcon		= LoadIcon( GhInst, MAKEINTRESOURCE(IDI_ICON) );
	wc.hCursor		= LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground= NULL;
	wc.lpszMenuName	= (LPCTSTR)NULL;
	wc.lpszClassName= (LPCTSTR)"bosewimeMainWndClass";
	wc.hIconSm		= NULL;//LoadIcon( GhInst, MAKEINTRESOURCE(IDI_ICON) );
	if( RegisterClassEx(&wc) == FALSE ){ return( FALSE ); }
	//	[EBhENXo^
	wc.lpfnWndProc	= ViewWndProc;
	wc.lpszClassName= (LPCTSTR)"bosewimeViewWndClass";
	if( RegisterClassEx(&wc) == FALSE ){ return( FALSE ); }

	//	CEBhE
	hWnd = CreateWindowEx( 0//WS_EX_CLIENTEDGE
		,"bosewimeMainWndClass"
		,"BoSeWiMe - "
		,WS_CLIPCHILDREN | WS_OVERLAPPEDWINDOW// | WS_CLIPSIBLINGS
		,0 ,0 ,0 ,0
		,NULL
		,NULL
		,GhInst
		,NULL
	);
	if( hWnd == NULL ){ return( FALSE ); }
	ShowWindow( hWnd, nCmdShow );
	UpdateWindow( hWnd );

	//	bZ[W[v
	while( GetMessage(&msg,NULL,0,0) ){
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}

	//	~EebNXJ
	ReleaseMutex( hMutex );

 	return( msg.wParam );
}



//	CEBhEER[obN
LRESULT CALLBACK MainWndProc( HWND hWnd, UINT msg, WPARAM wP, LPARAM lP )
{
	static RECT		rc;
	static HDC		hdc;
	static BOOL		bHook = FALSE;

	switch( msg ){
	case WM_CREATE:
		GhMainWnd = hWnd;
		for( int i=0; i<=MAX_DSPLOGSTR; i++ ){ GdsplogStr[i] = NULL; }
		LoadIniFile();
		InitToolBar( hWnd );
		CreateStatusBarSizeAdjustWindow( hWnd );
		//[쐬
		GhViewWnd = CreateWindowEx( WS_EX_CLIENTEDGE, "bosewimeViewWndClass", ""//WS_EX_CLIENTEDGE
			,WS_CHILD | WS_VISIBLE | WS_VSCROLL// | WS_CLIPSIBLINGS// | WS_BORDER
			,0 ,0 ,0 ,0
			,hWnd, NULL, GhInst, NULL
		);
		//o͐EBhEnh̎w
		SetOutputWindow( hWnd );
		break;

	case WMU_HOOK:
		OnWMU_HOOK( wP, lP );
		break;

	case WM_COMMAND:
		switch( LOWORD(wP) ){
		case IDM_SAVE:
			break;
		case IDM_SNAPSHOT:
			//IꂽvZX܂݂邩
			if( GhHookWnd != NULL ){
				if( IsWindowVisible(GhHookWnd) == 0 ){
					goto LB_IDM_PAUSE;
				}
			}
			BOOL	bIconic;
			if( GhHookWnd != NULL ){
				SetWindowPos( GhHookWnd, HWND_TOP, 0,0,0,0, SWP_NOMOVE|SWP_NOSIZE|SWP_SHOWWINDOW );// SWP_ASYNCWINDOWPOS
				bIconic = IsIconic( GhHookWnd );
				if( bIconic == TRUE ){ 
					ShowWindow( GhHookWnd, SW_SHOWNORMAL );
				}
				Sleep(500);
				SetClipBoardDataWndSnapShot( GhHookWnd );
				if( bIconic == TRUE ){ 
					ShowWindow( GhHookWnd, SW_MINIMIZE );
				}
			}
			break;
		case IDM_DELALLLOG:
			Glgi.FreeAllLog();
			InitScroll( GhViewWnd );
			ReDrawViewWindow();
			break;
		case IDM_SELPROC:
			if( bHook == TRUE ){
				ResetHook();
				bHook = FALSE;
			}
			Glgi.FreeAllLog();
			InitScroll( GhViewWnd );
			ReDrawViewWindow();
			SendMessage( GhToolWnd, TB_ENABLEBUTTON, IDM_SNAPSHOT, MAKELONG(FALSE,0) );
			SendMessage( GhToolWnd, TB_ENABLEBUTTON, IDM_START, MAKELONG(FALSE,0) );
			SendMessage( GhToolWnd, TB_ENABLEBUTTON, IDM_PAUSE, MAKELONG(FALSE,0) );
			int		id;
			id = DialogBoxParam( GhInst, MAKEINTRESOURCE(SELPROC_DLG), hWnd, (DLGPROC)SelectProcessDlgProc,(LPARAM)hWnd );
			if( id == IDOK ){
				SendMessage( GhToolWnd, TB_ENABLEBUTTON, IDM_SNAPSHOT, MAKELONG(TRUE,0) );
				SendMessage( GhToolWnd, TB_ENABLEBUTTON, IDM_START, MAKELONG(TRUE,0) );
			}
			break;
		case IDM_START:
			//IꂽvZX܂݂邩
			if( IsWindowVisible(GhHookWnd) == 0 ){
				goto LB_IDM_PAUSE;
			}
			//IꂽvZX̃XbhID擾
			GhHookThreadId = GetWindowThreadProcessId( GhHookWnd, NULL );
			if( SetHook(GhHookThreadId) == TRUE ){
				SendMessage( GhToolWnd, TB_ENABLEBUTTON, IDM_START, MAKELONG(FALSE,0) );
				SendMessage( GhToolWnd, TB_ENABLEBUTTON, IDM_PAUSE, MAKELONG(TRUE,0) );
				bHook = TRUE;
			}
			break;
		case IDM_PAUSE:
		LB_IDM_PAUSE:
			BOOL	bl;
			if( (ResetHook() != TRUE) || (IsWindowVisible(GhHookWnd) != TRUE) ){
				bl = FALSE;
				SetWindowText( hWnd, "BoSeWiMe - " );
				GhHookWnd = NULL;
			}
			SendMessage( GhToolWnd, TB_ENABLEBUTTON, IDM_SNAPSHOT, MAKELONG(bl,0) );
			SendMessage( GhToolWnd, TB_ENABLEBUTTON, IDM_START, MAKELONG(bl,0) );
			SendMessage( GhToolWnd, TB_ENABLEBUTTON, IDM_PAUSE, MAKELONG(FALSE,0) );
			bHook = FALSE;
			break;
		}
		break;

	case WM_ACTIVATE:
		//IꂽvZX܂݂邩
		if( GhHookWnd != NULL ){
			if( IsWindowVisible(GhHookWnd) == 0 ){
				goto LB_IDM_PAUSE;
			}
		}

	case WM_SIZE:
		SendMessage( GhToolWnd, WM_SIZE, wP, lP );
		int	toolh;
		GetWindowRect( GhToolWnd, &rc );
		toolh = rc.bottom-rc.top;
		GetClientRect( hWnd, &rc );
		MoveWindow( GhViewWnd, rc.left, rc.top+toolh, rc.right, rc.bottom-toolh-STATUSWND_H, TRUE );
		GetClientRect( hWnd, &rc );
		MoveWindow( GhStatusWnd, rc.right-STATUSWND_H, rc.bottom-STATUSWND_H, STATUSWND_H, STATUSWND_H, FALSE );
		break;

	case WM_NCPAINT:
		hdc = GetDC( hWnd );
		ReDrawStatusWindow( hdc );
		ReleaseDC( hWnd, hdc );
		goto LB_default;
	case WM_PAINT:
		PAINTSTRUCT		ps;
		hdc = BeginPaint( hWnd, &ps );
		ReDrawStatusWindow( hdc );
		EndPaint( hWnd, &ps );
		break;

	case WM_CLOSE:
		if( bHook == TRUE ){ ResetHook(); }
		SaveIniFile();
		DestroyWindow( hWnd );
		break;

	case WM_DESTROY:
		PostQuitMessage( 0 );
		break;

	default:
	LB_default:
		return( DefWindowProc(hWnd,msg,wP,lP) );
	}

	return( 0 );
}

void OnWMU_HOOK( WPARAM wP, LPARAM lP )
{
#define WM_GETOBJECT                    0x003D
#define WM_NCXBUTTONDOWN                0x00AB
#define WM_NCXBUTTONUP                  0x00AC
#define WM_NCXBUTTONDBLCLK              0x00AD
#define WM_MENURBUTTONUP                0x0122
#define WM_MENUDRAG                     0x0123
#define WM_MENUGETOBJECT                0x0124
#define WM_UNINITMENUPOPUP              0x0125
#define WM_MENUCOMMAND                  0x0126
#define WM_CHANGEUISTATE                0x0127
#define WM_UPDATEUISTATE                0x0128
#define WM_QUERYUISTATE                 0x0129
#define WM_XBUTTONDOWN                  0x020B
#define WM_XBUTTONUP                    0x020C
#define WM_XBUTTONDBLCLK                0x020D
#define WM_IME_REQUEST                  0x0288
#define WM_NCMOUSEHOVER                 0x02A0
#define WM_NCMOUSELEAVE                 0x02A2
#define WM_APPCOMMAND                   0x0319

	char	*str = NULL;
	char	tmpStr[40];

	switch( wP ){
	case WM_NULL:					str = "WM_NULL"						; break;
	case WM_CREATE:					str = "WM_CREATE"					; break;
	case WM_DESTROY:				str = "WM_DESTROY"					; break;
	case WM_MOVE:					str = "WM_MOVE"						; break;
	case WM_SIZE:					str = "WM_SIZE"						; break;
	case WM_ACTIVATE:				str = "WM_ACTIVATE"					; break;
	case WM_SETFOCUS:				str = "WM_SETFOCUS"					; break;
	case WM_KILLFOCUS:				str = "WM_KILLFOCUS"				; break;
	case WM_ENABLE:					str = "WM_ENABLE"					; break;
	case WM_SETREDRAW:				str = "WM_SETREDRAW"				; break;
	case WM_SETTEXT:				str = "WM_SETTEXT"					; break;
	case WM_GETTEXT:				str = "WM_GETTEXT"					; break;
	case WM_GETTEXTLENGTH:			str = "WM_GETTEXTLENGTH"			; break;
	case WM_PAINT:					str = "WM_PAINT"					; break;
	case WM_CLOSE:					str = "WM_CLOSE"					; break;
	case WM_QUERYENDSESSION:		str = "WM_QUERYENDSESSION"			; break;
	case WM_QUIT:					str = "WM_QUIT"						; break;
	case WM_QUERYOPEN:				str = "WM_QUERYOPEN"				; break;
	case WM_ERASEBKGND:				str = "WM_ERASEBKGND"				; break;
	case WM_SYSCOLORCHANGE:			str = "WM_SYSCOLORCHANGE"			; break;
	case WM_ENDSESSION:				str = "WM_ENDSESSION"				; break;
	case WM_SHOWWINDOW:				str = "WM_SHOWWINDOW"				; break;
	case WM_SETTINGCHANGE:			str = "WM_SETTINGCHANGE"			; break;
	case WM_DEVMODECHANGE:			str = "WM_DEVMODECHANGE"			; break;
	case WM_ACTIVATEAPP:			str = "WM_ACTIVATEAPP"				; break;
	case WM_FONTCHANGE:				str = "WM_FONTCHANGE"				; break;
	case WM_TIMECHANGE:				str = "WM_TIMECHANGE"				; break;
	case WM_CANCELMODE:				str = "WM_CANCELMODE"				; break;
	case WM_SETCURSOR:				str = "WM_SETCURSOR"				; break;
	case WM_MOUSEACTIVATE:			str = "WM_MOUSEACTIVATE"			; break;
	case WM_CHILDACTIVATE:			str = "WM_CHILDACTIVATE"			; break;
	case WM_QUEUESYNC:				str = "WM_QUEUESYNC"				; break;
	case WM_GETMINMAXINFO:			str = "WM_GETMINMAXINFO"			; break;
	case WM_PAINTICON:				str = "WM_PAINTICON"				; break;
	case WM_ICONERASEBKGND:			str = "WM_ICONERASEBKGND"			; break;
	case WM_NEXTDLGCTL:				str = "WM_NEXTDLGCTL"				; break;
	case WM_SPOOLERSTATUS:			str = "WM_SPOOLERSTATUS"			; break;
	case WM_DRAWITEM:				str = "WM_DRAWITEM"					; break;
	case WM_MEASUREITEM:			str = "WM_MEASUREITEM"				; break;
	case WM_DELETEITEM:				str = "WM_DELETEITEM"				; break;
	case WM_VKEYTOITEM:				str = "WM_VKEYTOITEM"				; break;
	case WM_CHARTOITEM:				str = "WM_CHARTOITEM"				; break;
	case WM_SETFONT:				str = "WM_SETFONT"					; break;
	case WM_GETFONT:				str = "WM_GETFONT"					; break;
	case WM_SETHOTKEY:				str = "WM_SETHOTKEY"				; break;
	case WM_GETHOTKEY:				str = "WM_GETHOTKEY"				; break;
	case WM_QUERYDRAGICON:			str = "WM_QUERYDRAGICON"			; break;
	case WM_COMPAREITEM:			str = "WM_COMPAREITEM"				; break;
	case WM_GETOBJECT:				str = "WM_GETOBJECT"				; break;
	case WM_COMPACTING:				str = "WM_COMPACTING"				; break;
	case WM_COMMNOTIFY:				str = "WM_COMMNOTIFY"				; break;
	case WM_WINDOWPOSCHANGING:		str = "WM_WINDOWPOSCHANGING"		; break;
	case WM_WINDOWPOSCHANGED:		str = "WM_WINDOWPOSCHANGED"			; break;
	case WM_POWER:					str = "WM_POWER"					; break;
	case WM_COPYDATA:				str = "WM_COPYDATA"					; break;
	case WM_CANCELJOURNAL:			str = "WM_CANCELJOURNAL"			; break;
	case WM_NOTIFY:					str = "WM_NOTIFY"					; break;
	case WM_INPUTLANGCHANGEREQUEST:	str = "WM_INPUTLANGCHANGEREQUEST"	; break;
	case WM_INPUTLANGCHANGE:		str = "WM_INPUTLANGCHANGE"			; break;
	case WM_TCARD:					str = "WM_TCARD"					; break;
	case WM_HELP:					str = "WM_HELP"						; break;
	case WM_USERCHANGED:			str = "WM_USERCHANGED"				; break;
	case WM_NOTIFYFORMAT:			str = "WM_NOTIFYFORMAT"				; break;
	case WM_CONTEXTMENU:			str = "WM_CONTEXTMENU"				; break;
	case WM_STYLECHANGING:			str = "WM_STYLECHANGING"			; break;
	case WM_STYLECHANGED:			str = "WM_STYLECHANGED"				; break;
	case WM_DISPLAYCHANGE:			str = "WM_DISPLAYCHANGE"			; break;
	case WM_GETICON:				str = "WM_GETICON"					; break;
	case WM_SETICON:				str = "WM_SETICON"					; break;
	case WM_NCCREATE:				str = "WM_NCCREATE"					; break;
	case WM_NCDESTROY:				str = "WM_NCDESTROY"				; break;
	case WM_NCCALCSIZE:				str = "WM_NCCALCSIZE"				; break;
	case WM_NCHITTEST:				str = "WM_NCHITTEST"				; break;
	case WM_NCPAINT:				str = "WM_NCPAINT"					; break;
	case WM_NCACTIVATE:				str = "WM_NCACTIVATE"				; break;
	case WM_GETDLGCODE:				str = "WM_GETDLGCODE"				; break;
	case WM_SYNCPAINT:				str = "WM_SYNCPAINT"				; break;
	case WM_NCMOUSEMOVE:			str = "WM_NCMOUSEMOVE"				; break;
	case WM_NCLBUTTONDOWN:			str = "WM_NCLBUTTONDOWN"			; break;
	case WM_NCLBUTTONUP:			str = "WM_NCLBUTTONUP"				; break;
	case WM_NCLBUTTONDBLCLK:		str = "WM_NCLBUTTONDBLCLK"			; break;
	case WM_NCRBUTTONDOWN:			str = "WM_NCRBUTTONDOWN"			; break;
	case WM_NCRBUTTONUP:			str = "WM_NCRBUTTONUP"				; break;
	case WM_NCRBUTTONDBLCLK:		str = "WM_NCRBUTTONDBLCLK"			; break;
	case WM_NCMBUTTONDOWN:			str = "WM_NCMBUTTONDOWN"			; break;
	case WM_NCMBUTTONUP:			str = "WM_NCMBUTTONUP"				; break;
	case WM_NCMBUTTONDBLCLK:		str = "WM_NCMBUTTONDBLCLK"			; break;
	case WM_NCXBUTTONDOWN:			str = "WM_NCXBUTTONDOWN"			; break;
	case WM_NCXBUTTONUP:			str = "WM_NCXBUTTONUP"				; break;
	case WM_NCXBUTTONDBLCLK:		str = "WM_NCXBUTTONDBLCLK"			; break;
	case WM_KEYDOWN:				str = "WM_KEYDOWN"					; break;
	case WM_KEYUP:					str = "WM_KEYUP"					; break;
	case WM_CHAR:					str = "WM_CHAR"						; break;
	case WM_DEADCHAR:				str = "WM_DEADCHAR"					; break;
	case WM_SYSKEYDOWN:				str = "WM_SYSKEYDOWN"				; break;
	case WM_SYSKEYUP:				str = "WM_SYSKEYUP"					; break;
	case WM_SYSCHAR:				str = "WM_SYSCHAR"					; break;
	case WM_SYSDEADCHAR:			str = "WM_SYSDEADCHAR"				; break;
	case WM_KEYLAST:				str = "WM_KEYLAST"					; break;
	case WM_IME_STARTCOMPOSITION:	str = "WM_IME_STARTCOMPOSITION"		; break;
	case WM_IME_ENDCOMPOSITION:		str = "WM_IME_ENDCOMPOSITION"		; break;
	case WM_IME_COMPOSITION:		str = "WM_IME_COMPOSITION"			; break;
	case WM_INITDIALOG:				str = "WM_INITDIALOG"				; break;
	case WM_COMMAND:				str = "WM_COMMAND"					; break;
	case WM_SYSCOMMAND:				str = "WM_SYSCOMMAND"				; break;
	case WM_TIMER:					str = "WM_TIMER"					; break;
	case WM_HSCROLL:				str = "WM_HSCROLL"					; break;
	case WM_VSCROLL:				str = "WM_VSCROLL"					; break;
	case WM_INITMENU:				str = "WM_INITMENU"					; break;
	case WM_INITMENUPOPUP:			str = "WM_INITMENUPOPUP"			; break;
	case WM_MENUSELECT:				str = "WM_MENUSELECT"				; break;
	case WM_MENUCHAR:				str = "WM_MENUCHAR"					; break;
	case WM_ENTERIDLE:				str = "WM_ENTERIDLE"				; break;
	case WM_MENURBUTTONUP:			str = "WM_MENURBUTTONUP"			; break;
	case WM_MENUDRAG:				str = "WM_MENUDRAG"					; break;
	case WM_MENUGETOBJECT:			str = "WM_MENUGETOBJECT"			; break;
	case WM_UNINITMENUPOPUP:		str = "WM_UNINITMENUPOPUP"			; break;
	case WM_MENUCOMMAND:			str = "WM_MENUCOMMAND"				; break;
	case WM_CHANGEUISTATE:			str = "WM_CHANGEUISTATE"			; break;
	case WM_UPDATEUISTATE:			str = "WM_UPDATEUISTATE"			; break;
	case WM_QUERYUISTATE:			str = "WM_QUERYUISTATE"				; break;
	case WM_CTLCOLORMSGBOX:			str = "WM_CTLCOLORMSGBOX"			; break;
	case WM_CTLCOLOREDIT:			str = "WM_CTLCOLOREDIT"				; break;
	case WM_CTLCOLORLISTBOX:		str = "WM_CTLCOLORLISTBOX"			; break;
	case WM_CTLCOLORBTN:			str = "WM_CTLCOLORBTN"				; break;
	case WM_CTLCOLORDLG:			str = "WM_CTLCOLORDLG"				; break;
	case WM_CTLCOLORSCROLLBAR:		str = "WM_CTLCOLORSCROLLBAR"		; break;
	case WM_CTLCOLORSTATIC:			str = "WM_CTLCOLORSTATIC"			; break;
	case WM_MOUSEMOVE:				str = "WM_MOUSEMOVE"				; break;
	case WM_LBUTTONDOWN:			str = "WM_LBUTTONDOWN"				; break;
	case WM_LBUTTONUP:				str = "WM_LBUTTONUP"				; break;
	case WM_LBUTTONDBLCLK:			str = "WM_LBUTTONDBLCLK"			; break;
	case WM_RBUTTONDOWN:			str = "WM_RBUTTONDOWN"				; break;
	case WM_RBUTTONUP:				str = "WM_RBUTTONUP"				; break;
	case WM_RBUTTONDBLCLK:			str = "WM_RBUTTONDBLCLK"			; break;
	case WM_MBUTTONDOWN:			str = "WM_MBUTTONDOWN"				; break;
	case WM_MBUTTONUP:				str = "WM_MBUTTONUP"				; break;
	case WM_MBUTTONDBLCLK:			str = "WM_MBUTTONDBLCLK"			; break;
	case WM_MOUSEWHEEL:				str = "WM_MOUSEWHEEL"				; break;
	case WM_XBUTTONDOWN:			str = "WM_XBUTTONDOWN"				; break;
	case WM_XBUTTONUP:				str = "WM_XBUTTONUP"				; break;
	case WM_XBUTTONDBLCLK:			str = "WM_XBUTTONDBLCLK"			; break;
	case WM_PARENTNOTIFY:			str = "WM_PARENTNOTIFY"				; break;
	case WM_ENTERMENULOOP:			str = "WM_ENTERMENULOOP"			; break;
	case WM_EXITMENULOOP:			str = "WM_EXITMENULOOP"				; break;
	case WM_NEXTMENU:				str = "WM_NEXTMENU"					; break;
	case WM_SIZING:					str = "WM_SIZING"					; break;
	case WM_CAPTURECHANGED:			str = "WM_CAPTURECHANGED"			; break;
	case WM_MOVING:					str = "WM_MOVING"					; break;
	case WM_POWERBROADCAST:			str = "WM_POWERBROADCAST"			; break;
	case WM_DEVICECHANGE:			str = "WM_DEVICECHANGE"				; break;
	case WM_MDICREATE:				str = "WM_MDICREATE"				; break;
	case WM_MDIDESTROY:				str = "WM_MDIDESTROY"				; break;
	case WM_MDIACTIVATE:			str = "WM_MDIACTIVATE"				; break;
	case WM_MDIRESTORE:				str = "WM_MDIRESTORE"				; break;
	case WM_MDINEXT:				str = "WM_MDINEXT"					; break;
	case WM_MDIMAXIMIZE:			str = "WM_MDIMAXIMIZE"				; break;
	case WM_MDITILE:				str = "WM_MDITILE"					; break;
	case WM_MDICASCADE:				str = "WM_MDICASCADE"				; break;
	case WM_MDIICONARRANGE:			str = "WM_MDIICONARRANGE"			; break;
	case WM_MDIGETACTIVE:			str = "WM_MDIGETACTIVE"				; break;
	case WM_MDISETMENU:				str = "WM_MDISETMENU"				; break;
	case WM_ENTERSIZEMOVE:			str = "WM_ENTERSIZEMOVE"			; break;
	case WM_EXITSIZEMOVE:			str = "WM_EXITSIZEMOVE"				; break;
	case WM_DROPFILES:				str = "WM_DROPFILES"				; break;
	case WM_MDIREFRESHMENU:			str = "WM_MDIREFRESHMENU"			; break;
	case WM_IME_SETCONTEXT:			str = "WM_IME_SETCONTEXT"			; break;
	case WM_IME_NOTIFY:				str = "WM_IME_NOTIFY"				; break;
	case WM_IME_CONTROL:			str = "WM_IME_CONTROL"				; break;
	case WM_IME_COMPOSITIONFULL:	str = "WM_IME_COMPOSITIONFULL"		; break;
	case WM_IME_SELECT:				str = "WM_IME_SELECT"				; break;
	case WM_IME_CHAR:				str = "WM_IME_CHAR"					; break;
	case WM_IME_REQUEST:			str = "WM_IME_REQUEST"				; break;
	case WM_IME_KEYDOWN:			str = "WM_IME_KEYDOWN"				; break;
	case WM_IME_KEYUP:				str = "WM_IME_KEYUP"				; break;
	case WM_NCMOUSEHOVER:			str = "WM_NCMOUSEHOVER"				; break;
	case WM_MOUSEHOVER:				str = "WM_MOUSEHOVER"				; break;
	case WM_NCMOUSELEAVE:			str = "WM_NCMOUSELEAVE"				; break;
	case WM_MOUSELEAVE:				str = "WM_MOUSELEAVE"				; break;
	case WM_CUT:					str = "WM_CUT"						; break;
	case WM_COPY:					str = "WM_COPY"						; break;
	case WM_PASTE:					str = "WM_PASTE"					; break;
	case WM_CLEAR:					str = "WM_CLEAR"					; break;
	case WM_UNDO:					str = "WM_UNDO"						; break;
	case WM_RENDERFORMAT:			str = "WM_RENDERFORMAT"				; break;
	case WM_RENDERALLFORMATS:		str = "WM_RENDERALLFORMATS"			; break;
	case WM_DESTROYCLIPBOARD:		str = "WM_DESTROYCLIPBOARD"			; break;
	case WM_DRAWCLIPBOARD:			str = "WM_DRAWCLIPBOARD"			; break;
	case WM_PAINTCLIPBOARD:			str = "WM_PAINTCLIPBOARD"			; break;
	case WM_VSCROLLCLIPBOARD:		str = "WM_VSCROLLCLIPBOARD"			; break;
	case WM_SIZECLIPBOARD:			str = "WM_SIZECLIPBOARD"			; break;
	case WM_ASKCBFORMATNAME:		str = "WM_ASKCBFORMATNAME"			; break;
	case WM_CHANGECBCHAIN:			str = "WM_CHANGECBCHAIN"			; break;
	case WM_HSCROLLCLIPBOARD:		str = "WM_HSCROLLCLIPBOARD"			; break;
	case WM_QUERYNEWPALETTE:		str = "WM_QUERYNEWPALETTE"			; break;
	case WM_PALETTEISCHANGING:		str = "WM_PALETTEISCHANGING"		; break;
	case WM_PALETTECHANGED:			str = "WM_PALETTECHANGED"			; break;
	case WM_HOTKEY:					str = "WM_HOTKEY"					; break;
	case WM_PRINT:					str = "WM_PRINT"					; break;
	case WM_PRINTCLIENT:			str = "WM_PRINTCLIENT"				; break;
	case WM_APPCOMMAND:				str = "WM_APPCOMMAND"				; break;
	case WM_HANDHELDFIRST:			str = "WM_HANDHELDFIRST"			; break;
	case WM_HANDHELDLAST:			str = "WM_HANDHELDLAST"				; break;
	case WM_AFXFIRST:				str = "WM_AFXFIRST"					; break;
	case WM_AFXLAST:				str = "WM_AFXLAST"					; break;
	case WM_PENWINFIRST:			str = "WM_PENWINFIRST"				; break;
	case WM_PENWINLAST:				str = "WM_PENWINLAST"				; break;
	}
	//[U[`bZ[W̏ꍇ̏
	if( (wP >= WM_USER) && (wP <= 0xFFFF) ){
		wsprintf( tmpStr, "WM_USER+%d", wP-WM_USER );
		str = tmpStr;
	}
	if( str == NULL ){
		wsprintf( tmpStr, "???????:0x%04x", wP );
		str = tmpStr;
	}
	Glgi.AddItemString( str );
	SetScrollPage( GhViewWnd, &Glgi );
	return;
}



//	[EBhEER[obN
LRESULT CALLBACK ViewWndProc( HWND hWnd, UINT msg, WPARAM wP, LPARAM lP )
{
	static PAINTSTRUCT		ps;
	static RECT				rc;
	static HDC				hdc;

	switch( msg ){
	case WM_CREATE:
		GhViewWnd = hWnd;
		//cb쐬
		GetClientRect( GetDesktopWindow(), &rc );
		hdc = GetDC( hWnd );
		GhViewMemdc = CreateCompatibleDC( hdc );
		GhViewBit = CreateCompatibleBitmap( hdc, rc.right, rc.bottom );
		GhViewBitOld = (HBITMAP)SelectObject( GhViewMemdc, GhViewBit );
		ReleaseDC( hWnd, hdc );
		FillRect( GhViewMemdc, &rc, (HBRUSH)(COLOR_WINDOW+1) );
		//[EBhẼtHg쐬Kp
		GhViewFnt = CreateFont( -GsizeViewFntH, 0, 0, 0, GsizeViewFntW
			,FALSE, FALSE, FALSE
			,DEFAULT_CHARSET
			,OUT_DEFAULT_PRECIS
			,CLIP_DEFAULT_PRECIS
			,DEFAULT_QUALITY
			,FF_DONTCARE | DEFAULT_PITCH
			,(LPCTSTR)GsViewFntFace
		);
		GhViewFntOld = (HFONT)SelectObject( GhViewMemdc, GhViewFnt );
		//eLXgFݒ
	 	SetBkColor( GhViewMemdc, GetSysColor(COLOR_WINDOW) );
	 	SetTextColor( GhViewMemdc, GetSysColor(COLOR_WINDOWTEXT) );
		//XN[o[̂܂݃TCY
		InitScroll( hWnd );
		break;

	case WM_VSCROLL:
		OnWM_VSCROLL( hWnd, &Glgi, wP );
		ReDrawViewWindow();
		break;

	case WM_SIZE:
		SetScrollPage( GhViewWnd, &Glgi );
		break;

	case WM_PAINT:
		hdc = BeginPaint( hWnd, &ps );
		BitBlt( hdc
			,ps.rcPaint.left
			,ps.rcPaint.top
			,ps.rcPaint.right - ps.rcPaint.left
			,ps.rcPaint.bottom - ps.rcPaint.top
			,GhViewMemdc
			,ps.rcPaint.left
			,ps.rcPaint.top
			,SRCCOPY
		);
		EndPaint( hWnd, &ps );
		break;

	case WM_DESTROY:
		//	tHgnĥĂ
		SelectObject( GhViewMemdc, GhViewFntOld );
		DeleteObject( GhViewFnt );
		//	zʂ̂Ă
		SelectObject( GhViewMemdc, GhViewBitOld );
		DeleteObject( GhViewBit );//	rbg}bvnĥĂ
		DeleteDC( GhViewMemdc );
		break;

	default:
		return( DefWindowProc(hWnd,msg,wP,lP) );
	}

	return( 0 );
}



//	XN[o[̈ʒuXV
void OnWM_VSCROLL( HWND hWnd, LOGINFO *lgi, WPARAM wP )
{
	SCROLLINFO		si;
	RECT			rc;
	int				max;

	GetClientRect( hWnd, &rc );
	max = lgi->GetItemCount()-(rc.bottom/GsizeViewFntH)-1;

	switch( LOWORD(wP) ){
	case SB_LINEUP:
	case SB_PAGEUP:
		if( GposViewScrollV > 0 ){ GposViewScrollV--; }
		break;
	case SB_LINEDOWN:
	case SB_PAGEDOWN:
		if( GposViewScrollV < max ){ GposViewScrollV++; }
		break;
	case SB_THUMBTRACK:
	case SB_THUMBPOSITION:
		si.cbSize = sizeof(SCROLLINFO);
		si.fMask  = SIF_TRACKPOS;
		GetScrollInfo( hWnd, SB_VERT, &si );
		GposViewScrollV = si.nTrackPos;
		break;
	}
	si.cbSize = sizeof( SCROLLINFO );
	si.fMask  = SIF_POS;
	si.nPos   = GposViewScrollV;
	SetScrollInfo( hWnd, SB_VERT, &si, TRUE );

	return;
}

//	XN[o[̂܂݃TCY
void InitScroll( HWND hWnd )
{
	SCROLLINFO		si;
	RECT			rc;
	int				page;

	GetClientRect( hWnd, &rc );
	page = rc.bottom/GsizeViewFntH;
	si.cbSize = sizeof( SCROLLINFO );
	si.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;// | SIF_DISABLENOSCROLL;
	si.nPage  = page+1;
	si.nMin   = 0;
	si.nMax   = 0;
	si.nPos   = 0;
	SetScrollInfo( hWnd, SB_VERT, &si, TRUE );

	return;
}

//	XN[o[̂܂݃TCYXV
void SetScrollPage( HWND hWnd, LOGINFO *lgi )
{
	SCROLLINFO		si;
	RECT			rc;
	int				num, page;

	GetClientRect( hWnd, &rc );
	num  = lgi->GetItemCount();
	page = rc.bottom/GsizeViewFntH;
	si.cbSize = sizeof( SCROLLINFO );
	si.fMask  = SIF_RANGE | SIF_PAGE| SIF_POS;// | SIF_DISABLENOSCROLL;
	si.nPage  = page+1;
	si.nMin   = 0;
	si.nMax   = num;
	if( (page > (num-GposViewScrollV)) || (GetFocus() != GhViewWnd) ){
		GposViewScrollV = num-page;
	}
	if( GposViewScrollV < 0 ){
		GposViewScrollV = 0;
	}
	si.nPos   = GposViewScrollV;
	SetScrollInfo( hWnd, SB_VERT, &si, TRUE );
	ReDrawViewWindow();

	return;
}



//	[EBhEȂ
void ReDrawViewWindow( void )
{
	RECT		rc;
	int			pos;
	int			getNum;
	BOOL		bl;

	GetClientRect( GhViewWnd, &rc );
	getNum = rc.bottom/GsizeViewFntH;
	if( getNum > MAX_DSPLOGSTR ){ getNum = MAX_DSPLOGSTR; }
	FillRect( GhViewMemdc, &rc, (HBRUSH)(COLOR_WINDOW+1) );
	bl = Glgi.GetItemString( GposViewScrollV, getNum, GdsplogStr, MAX_DSPLOGSTR );
	if( (GdsplogStr[0] != NULL) && (bl == TRUE) ){
		for( int i=0; i<getNum; i++ ){
			if( GdsplogStr[i] != NULL ){
			 	TextOut( GhViewMemdc, 0, i*GsizeViewFntH, (LPCTSTR)GdsplogStr[i], lstrlen(GdsplogStr[i]) );
			}
		}
	}
	InvalidateRect( GhViewWnd, NULL, FALSE );

	return;
}



void SetClipBoardDataWndSnapShot( HWND hWnd )
{
	HWND		hDesktopWnd;
	RECT		rc;
	HDC			hMemDc, hDesctopDc;
	HBITMAP		hBitmap, hBitmapOld;
	int			cx, cy;

	GetWindowRect( hWnd, &rc );
	cx = rc.right-rc.left;
	cy = rc.bottom-rc.top;
	hDesktopWnd = GetDesktopWindow();
	hDesctopDc = GetDC( hDesktopWnd );
	//
	hMemDc = CreateCompatibleDC( hDesctopDc );
	hBitmap = CreateCompatibleBitmap( hDesctopDc, cx, cy );
	if( hBitmap != NULL ){
		hBitmapOld = (HBITMAP)SelectObject( hMemDc, hBitmap );
		BitBlt( hMemDc, 0,0, cx, cy, hDesctopDc, rc.left, rc.top, SRCCOPY );
		OpenClipboard( GhMainWnd );
		EmptyClipboard();
		SetClipboardData( CF_BITMAP, hBitmap );
		CloseClipboard();
		SelectObject( hMemDc, hBitmapOld );
	}else{
		;
	}
	DeleteDC( hMemDc );
	ReleaseDC( hDesktopWnd, hDesctopDc ); 

	return;
}





//	c[o[쐬
void InitToolBar( HWND hWnd )
{
	#define		TBS_ABT		TBSTYLE_BUTTON | TBSTYLE_TOOLTIPS
	#define		TBS_ACT		TBSTYLE_CHECK | TBSTYLE_TOOLTIPS
	TBBUTTON	tbs = {  0, 0          , TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0 };
	TBBUTTON	tbb[] = {
					{ 0, IDM_SAVE     , TBSTATE_ELLIPSES, TBS_ABT    , 0, 0 },
					{ 1, IDM_DELALLLOG, TBSTATE_ENABLED , TBS_ABT    , 0, 0 },
					{ 2, IDM_SELPROC  , TBSTATE_ENABLED , TBS_ABT    , 0, 0 },
					{ 3, IDM_START    , TBSTATE_ELLIPSES, TBS_ABT    , 0, 0 },
					{ 4, IDM_PAUSE    , TBSTATE_ELLIPSES, TBS_ABT    , 0, 0 },
					{ 5, IDM_SNAPSHOT , TBSTATE_ELLIPSES, TBS_ABT    , 0, 0 }
				};

	GhToolWnd = CreateToolbarEx( hWnd
		,WS_CHILD | WS_VISIBLE | CCS_NODIVIDER
		,IDC_TOOLBAR
		,TOOLNUM
		,GhInst
		,IDB_TOOL//MAKEINTRESOURCE( IDB_TOOL )
		,tbb
		,TOOLNUM
		,TOOLBMPSIZE
		,TOOLBMPSIZE
		,TOOLSIZE
		,TOOLSIZE
		,sizeof( TBBUTTON )
	);
	//c[`bvt
	HWND		htWnd;
	TOOLINFO	ti;
	htWnd = CreateWindowEx( 0, TOOLTIPS_CLASS, "", TTS_ALWAYSTIP//|TTS_BALLOON
		,CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT
		,hWnd, NULL, GhInst, NULL
	);
	ti.cbSize = sizeof(TOOLINFO);
	ti.uFlags = TTF_SUBCLASS;
	ti.hwnd   = GhToolWnd;
	ti.hinst  = GhInst;
	for( int i=0; i<TOOLNUM; i++ ){
		if( tbb[i].idCommand != 0 ){
			SendMessage( htWnd, TB_GETITEMRECT, i, (LPARAM)&ti.rect );
			ti.uId      = tbb[i].idCommand;
			ti.lpszText = (LPTSTR)MAKEINTRESOURCE( tbb[i].idCommand );
			SendMessage( htWnd, TTM_ADDTOOL, 0, (LPARAM)&ti );
		}
	}
	SendMessage( GhToolWnd, TB_SETTOOLTIPS, (WPARAM)htWnd, 0 );
	//	ݒ
	SendMessage( htWnd, TTM_SETMAXTIPWIDTH, 0, (LPARAM)240 );
	//	c[o[Eɂ炷
	SendMessage( GhToolWnd, TB_SETINDENT, TOOLSIZE/4, 0 );
	//	Zp[^[}
	SendMessage( GhToolWnd, TB_INSERTBUTTON, 5, (LPARAM)&tbs);
	SendMessage( GhToolWnd, TB_INSERTBUTTON, 3, (LPARAM)&tbs);
	SendMessage( GhToolWnd, TB_INSERTBUTTON, 2, (LPARAM)&tbs);

	return;
}



//	hmht@Cǂݍ
void LoadIniFile( void )
{
	char	str[40];

	//	CEBhËʒu/TCY
	int		x, y, wx, wy;
	GetPrivateProfileString( "WINDOW", "pos_x", "100", (LPTSTR)str, 6, GsIniPath );
	x = atoi( str ); 
	GetPrivateProfileString( "WINDOW", "pos_y", "100", (LPTSTR)str, 6, GsIniPath );
	y = atoi( str ); 
	GetPrivateProfileString( "WINDOW", "siz_x", "640", (LPTSTR)str, 6, GsIniPath );
	wx = atoi( str ); 
	GetPrivateProfileString( "WINDOW", "siz_y", "640", (LPTSTR)str, 6, GsIniPath );
	wy = atoi( str );
	SetWindowPos( GhMainWnd, NULL, x, y, wx, wy, SWP_NOZORDER );//|SWP_SHOWWINDOW );
	//	[EBhẼtHg
	GetPrivateProfileString( "viewFONT", "height", "13", (LPTSTR)str, 6, GsIniPath );
	GsizeViewFntH = atoi( str );
	GetPrivateProfileString( "viewFONT", "weight", "700", (LPTSTR)str, 6, GsIniPath );
	GsizeViewFntW = atoi( str );
	GetPrivateProfileString( "viewFONT", "name", "lr oSVbN", (LPTSTR)GsViewFntFace, sizeof(GsViewFntFace), GsIniPath );
	//	tO
//	GetPrivateProfileString( "FLAG", "statusWndFlag", "1", (LPTSTR)str, 6, GsIniPath );
//	GstatusWndFlag = atoi( str );
//	GetPrivateProfileString( "FLAG", "grid", "1", (LPTSTR)str, 6, GsIniPath );
//	GfGrid = atoi( str );
	return;
}

//	hmht@C
void SaveIniFile( void )
{
	RECT	rc;
	int		cy;
	char	str[11];

	//	CEBhËʒu/TCY
	if( IsIconic(GhMainWnd) == FALSE ){
		GetWindowRect( GhMainWnd, &rc );
		wsprintf( str, "%d", rc.left );
		WritePrivateProfileString( "WINDOW", "pos_x", str, GsIniPath );
		wsprintf( str, "%d", rc.top );
		WritePrivateProfileString( "WINDOW", "pos_y", str, GsIniPath );
		wsprintf( str, "%d", rc.right-rc.left );
		WritePrivateProfileString( "WINDOW", "siz_x", str, GsIniPath );
		/*if( GstatusWndFlag == TRUE ){ cy = rc.bottom-rc.top-STATUSWND_H; }else{ */cy = rc.bottom-rc.top;/* }*/
		wsprintf( str, "%d", cy );
		WritePrivateProfileString( "WINDOW", "siz_y", str, GsIniPath );
	}
	//	tO
//	wsprintf( str, "%d", GstatusWndFlag );
//	WritePrivateProfileString( "FLAG", "statusWndFlag", str, GsIniPath );
//	wsprintf( str, "%d", GfGrid );
//	WritePrivateProfileString( "FLAG", "grid", str, GsIniPath );
	return;
}











