
#include	<windows.h>



//	gG[\
void SeeError( void )
{
	DWORD	code;
	char	str[1024];
	LPVOID	lpMsgBuf;

	code = GetLastError();
	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS
		,NULL
		,code
		,MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT)
		,(LPTSTR)&lpMsgBuf
		,0
		,NULL
	);
	wsprintf( str, "error code = %d", code );
	MessageBox( NULL, (LPCTSTR)lpMsgBuf, (LPCTSTR)str, MB_OK | MB_ICONINFORMATION );
	LocalFree( lpMsgBuf );

	return;
}



///////////////////////////////////////////////////////////////////////
//				}N
///////////////////////////////////////////////////////////////////////
#define		TOOLNUM			6
#define		TOOLSIZE		20
#define		TOOLBMPSIZE		16

#define		STATUSWND_H		12

#define		MAX_DSPLOGSTR	256



///////////////////////////////////////////////////////////////////////
//				\́ENX
///////////////////////////////////////////////////////////////////////
//	Of[^
struct LOGDATA{
		LOGDATA		*fwd;
		LOGDATA		*nxt;
		char		*str;
};

//	OCtH
class LOGINFO{
	protected:
		LOGDATA		*first;
		LOGDATA		*last;
		int			num;
	public:
		LOGINFO( void );		//	RXgN^
		~LOGINFO( void );		//	fXgN^
		BOOL AddItemString( char *string );
		BOOL GetItemString( int index, int getNum, char *retStr[], int retStrSize );
		void FreeAllLog( void );
		int GetItemCount( void );
};
	//	RXgN^
LOGINFO::LOGINFO( void )
{
	first = NULL;
	last = NULL;
	num = 0;
}
	//	fXgN^
LOGINFO::~LOGINFO( void )
{
	FreeAllLog();
}
	//	SẴOobt@J
void LOGINFO::FreeAllLog( void )
{
	LOGDATA		*now, *nxt;

	now = first;
	while( now != NULL ){
		nxt = now->nxt;
		if( now->str != NULL ){
			delete []now->str;
		}
		delete now;
		now = nxt;
	}
	first = NULL;
	last = NULL;
	num = 0;
	return;
}
	//	O̍Ōɕǉ
BOOL LOGINFO::AddItemString( char *string )
{
	LOGDATA		*lgd;
	char		*str;
	int			len;

	len = lstrlen( string );
	//	m
	try{
		lgd = new LOGDATA;	
	}
	catch( std::bad_alloc& ){
		goto LB_bad_alloc;
	}
	try{
		str = new char[len+1];	
	}
	catch( std::bad_alloc& ){
		delete lgd;
		goto LB_bad_alloc;
	}
	//	
	if( first == NULL ){
		//	n߂Ă̎
		first = lgd;
		lgd->fwd = NULL;
	}else{
		//	n߂ĈȊO̎́Alast̎̈ʒuɑ}
		last->nxt = lgd;
		lgd->fwd = last;
	}
	lgd->nxt = NULL;
	last = lgd;
	last->str = str;
	//	Rs[
	int		p;
	for( p=0; p<len; p++ ){
		str[p] = string[p];
	}
	str[p] = '\0';
	num++;
	return( TRUE );
 
  LB_bad_alloc:
	MessageBox( NULL, (LPCTSTR)"mۂɎs", (LPCTSTR)"", MB_TASKMODAL | MB_OK | MB_ICONWARNING | MB_TOPMOST );
	return( FALSE );
  LB_bad_copy:
	MessageBox( NULL, (LPCTSTR)"Rs[Ɏs", (LPCTSTR)"", MB_TASKMODAL | MB_OK | MB_ICONWARNING | MB_TOPMOST );
	return( FALSE );
}
	//	wʒu̕擾
BOOL LOGINFO::GetItemString( int index, int getNum, char *retStr[], int retStrSize )
{
	LOGDATA		*now;
	int			i;

	if( (num <= index) || (index < 0) || (getNum <= 0) || (retStrSize <= 0) ){ return( FALSE ); }
	for( i=0; i<retStrSize+1; i++ ){
		retStr[i] = NULL;
	}
	if( (num-index) > index ){
		//first猟
		now = first;
		for( i=0; i<index; i++ ){
			if( now == NULL ){ break; }
			now = now->nxt;
		}
		for( i=0; i<getNum; i++ ){
			if( now == NULL ){ break; }
			retStr[i] = now->str;
			now = now->nxt;
		}
	}else{
		//last猟
		now = last;
		for( i=num; i>(index+getNum); i-- ){
			if( now == NULL ){ break; }
			now = now->fwd;
		}
		for( i=getNum-1; i>=0; i-- ){
			if( now == NULL ){ retStr[0] = NULL; break; }
			retStr[i] = now->str;
			now = now->fwd;
		}
	}

	return( TRUE );
}

	//	OACeԂ
int LOGINFO::GetItemCount( void )
{
	return( num );
}




///////////////////////////////////////////////////////////////////////
//				CC֐vg^Cv
///////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////
//				֐vg^Cv
///////////////////////////////////////////////////////////////////////
LRESULT CALLBACK MainWndProc( HWND, UINT, WPARAM, LPARAM );
LRESULT CALLBACK ViewWndProc( HWND hWnd, UINT msg, WPARAM wP, LPARAM lP );
LRESULT CALLBACK StatusWndProc( HWND hWnd, UINT msg, WPARAM wP, LPARAM lP );
LRESULT CALLBACK SelectProcessDlgProc( HWND hWnd, UINT msg, WPARAM wP, LPARAM lP );

void CreateStatusBarSizeAdjustWindow( HWND hWnd );
void ReDrawStatusWindow( HDC hdc );
void SaveIniFile( void );
void LoadIniFile( void );
void InitToolBar( HWND hWnd );
void InitChild( HWND hWnd );

void InitScroll( HWND hWnd );
void SetScrollPage( HWND hWnd, LOGINFO *lgi );
void OnWM_VSCROLL( HWND hWnd, LOGINFO *lgi, WPARAM wP );
void OnWMU_HOOK( WPARAM wP, LPARAM lP );

void ReDrawViewWindow( void );

void SetClipBoardDataWndSnapShot( HWND hWnd );


///////////////////////////////////////////////////////////////////////
//				O[oϐ
///////////////////////////////////////////////////////////////////////
HINSTANCE	GhInst;
char		GsModuleFolderPath[MAX_PATH];	//	vO{̃pX
char		GsIniPath[MAX_PATH];			//	t@CpX
LOGINFO		Glgi;
char		*GdsplogStr[MAX_DSPLOGSTR+1];

HWND		GhHookWnd = NULL;
DWORD		GhHookThreadId;
char		GsHookCaption[MAX_PATH+20];

//	C
HWND		GhMainWnd = NULL;

//	[
HWND		GhViewWnd = NULL;
HFONT		GhViewFnt, GhViewFntOld;
int			GsizeViewFntH, GsizeViewFntW;
HDC			GhViewMemdc;
HBITMAP		GhViewBit, GhViewBitOld;
char		GsViewFntFace[LF_FACESIZE];
int			GposViewScrollV = 0;

//	c[o[
HWND		GhToolWnd = NULL;

//	[Xe[^Xo[
HWND		GhStatusWnd = NULL;
BOOL		Gcapture = FALSE;



















