





//	[Xe[^Xo[쐬
void CreateStatusBarSizeAdjustWindow( HWND hWnd )
{
	WNDCLASSEX	wc;
	wc.cbSize		= sizeof(WNDCLASSEX);
	wc.style		= NULL;//CS_HREDRAW | CS_VREDRAW;//CS_DBLCLKS;
	wc.lpfnWndProc	= StatusWndProc;
	wc.cbClsExtra	= 0;
	wc.cbWndExtra	= 0;
	wc.hInstance	= GhInst;
	wc.hIcon		= NULL;
	wc.hCursor		= LoadCursor(NULL,IDC_SIZENWSE);
	wc.hbrBackground= (HBRUSH)NULL;
	wc.lpszMenuName	= (LPCTSTR)NULL;
	wc.lpszClassName= (LPCTSTR)"asWndClass";
	wc.hIconSm		= NULL;
	RegisterClassEx( &wc );
	//	[Xe[^Xo[TCYAWXg쐬
	CreateWindowEx( WS_EX_TRANSPARENT, "asWndClass", ""
		,WS_CHILD | WS_VISIBLE
		,0
		,0
		,0
		,0
		,hWnd, (HMENU)NULL, GhInst, NULL
	);
	return;
}

//	[Xe[^Xo[̃NCAg̈`
void ReDrawStatusWindow( HDC hdc )
{
	RECT	rc;//, rcL;//, rcR;
	HPEN	pen, pen1, penOld;
	int		xy1[] = { 11, 8, 5, 2, 10, 9, 7, 6, 4, 3, 1, -1 };
	int		p;
	
	//	TCYObv`
	GetClientRect( GhMainWnd, &rc );
	FillRect( hdc, &rc, (HBRUSH)(COLOR_3DFACE+1) );
	if( GhStatusWnd != NULL ){
		pen = CreatePen( PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT) );
		pen1 = CreatePen( PS_SOLID, 1, GetSysColor(COLOR_3DSHADOW) );

		penOld = (HPEN)SelectObject( hdc, pen );
		rc.right -= 2;
		p = 0;
		while( xy1[p] != 10 ){
			MoveToEx( hdc, rc.right, rc.bottom-xy1[p], NULL );
			LineTo( hdc, rc.right-(xy1[p]+1), rc.bottom+1 );
			p++;
		}
		SelectObject( hdc, pen1 );
		while( xy1[p] != -1 ){
			MoveToEx( hdc, rc.right, rc.bottom-xy1[p], NULL );
			LineTo( hdc, rc.right-(xy1[p]+1), rc.bottom+1 );
			p++;
		}
	}
	SelectObject( hdc, penOld );
	DeleteObject( pen );
	DeleteObject( pen1 );

	return;
}

//	[Xe[^Xo[TCYAWXgEBhEER[obN
LRESULT CALLBACK StatusWndProc( HWND hWnd, UINT msg, WPARAM wP, LPARAM lP )
{
	static RECT		rc;
	static POINT	mptBk;

	switch( msg ){
	case WM_CREATE:
		GhStatusWnd = hWnd;
		break;   
		
	case WM_LBUTTONUP:
		//	}EXLv`[
		if( Gcapture == TRUE ){
			Gcapture = FALSE;
			ReleaseCapture();
			SendMessage( GhMainWnd, WM_EXITSIZEMOVE, 0, 0 );
		}
		break;
		
	case WM_LBUTTONDOWN:
		//	}EXLv`[Jn
		if( IsZoomed(GhMainWnd) == TRUE ){
			ShowWindow( GhMainWnd, SW_RESTORE );
		}else{
			if( Gcapture == FALSE ){
				GetCursorPos( &mptBk );
				GetWindowRect( GhMainWnd, &rc );
				SetCapture( hWnd );
				Gcapture = TRUE;
			}
		}
		break;
		
	case WM_MOUSEMOVE:
		if( wP & MK_LBUTTON ){
			if( Gcapture == TRUE ){
				POINT	mpt;
				GetCursorPos( &mpt );
				SetWindowPos( GhMainWnd, NULL, 0, 0, (rc.right-rc.left)-(mptBk.x-mpt.x), (rc.bottom-rc.top)-(mptBk.y-mpt.y), SWP_NOMOVE | SWP_NOZORDER );//|SWP_SHOWWINDOW );
			}
		}
		break;
	case WM_DESTROY:
		GhStatusWnd = NULL;
		break;
		
	default:
		return( DefWindowProc( hWnd, msg, wP, lP ) );
    }
	return( 0 );
}





